#include "stdafx.h"
#include "Delaunay.h"


double GetAngle(D_DOT vec1,D_DOT vec2){
	double le1 = sqrt(vec1.x*vec1.x + vec1.y*vec1.y);
	double le2 = sqrt(vec2.x*vec2.x + vec2.y*vec2.y);
	double cosvalue = 0;
	if(le1>0.000000001&&le2>0.000000001){
		cosvalue = (vec1.x*vec2.x+vec1.y*vec2.y)/(le1*le2);
	}
	if(cosvalue<-1.0){
		cosvalue = -1.0;
	}
	if(cosvalue>1.0){
		cosvalue = 1.0;
	}
	double sss = acos(cosvalue);
	return 180.0*(acos(cosvalue)/M_PI);

}
bool operator ==(const D_DOT &dot1,const D_DOT&dot2){
	if(abs(dot1.x-dot2.x)<0.00001&&abs(dot1.y-dot2.y)<0.000001)
		return true;
	else 
		return false;
}
double Getlength(D_DOT dot1,D_DOT dot2){
	return sqrt((dot1.x - dot2.x) * (dot1.x - dot2.x) + (dot1.y-dot2.y)*(dot1.y-dot2.y)) ;
}
double GetLineLength(D_DOT* dot,int num){
	if(num<2){
		return 0;
	}
	double t = 0;
	for(int i=0;i<num-1;++i){
		t += Getlength(dot[i],dot[i+1]);
	}
	return t;

}

//õеstroke
void GetAllStroke(CSFeatureCls *lineCls,CStroke *st,long &renum){
	long snum = 0;
	CSFeatureSet lineset;
	lineCls->RectSelect(-1,NULL,&lineset);
	
	long roadnum = lineset.GetObjCount();
	if(roadnum>0){
		lineset.MoveLast();;
		TYPE_OBJ_ID maxid;
		lineset.GetObjID(&maxid);
		int *IsInStroke = new int[maxid+1];
		for(int i=0;i<maxid+1;++i){
			IsInStroke[i] = 0;
		}
		lineset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			lineset.GetObjID(&objid);
			CAnyLine linepnt;
			lineset.line_Get(objid,&linepnt);
			long dotnum = linepnt.m_varLin.dotNum();
			D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();
			double tl = GetLineLength(dot,dotnum);
			if(tl<0.0000001){
				IsInStroke[objid] = 1;
			}
		}while(lineset.MoveNext()!=END_OF_SET);
		lineset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			lineset.GetObjID(&objid);
			if(IsInStroke[objid]==0){
				CAnyLine linepnt;
				lineset.line_Get(objid,&linepnt);
				long dotnum = linepnt.m_varLin.dotNum();
				if(dotnum>1){
					D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();
					st[snum].AddRoad(objid,GetLineLength(dot,dotnum));
					IsInStroke[objid] = 1;

					D_DOT fristdot,lastdot,fristvec,lastvec;
					fristdot.x = dot[0].x;
					fristdot.y = dot[0].y;
					lastdot.x = dot[dotnum-1].x;
					lastdot.y = dot[dotnum-1].y;
					fristvec.x = dot[1].x - dot[0].x;
					fristvec.y = dot[1].y - dot[0].y;
					lastvec.x = dot[dotnum-2].x - dot[dotnum-1].x;
					lastvec.y = dot[dotnum-2].y - dot[dotnum-1].y;
					
					D_DOT itedot;
					D_DOT itevec;
					itedot.x = fristdot.x;
					itedot.y = fristdot.y;
					itevec.x = fristvec.x;
					itevec.y = fristvec.y;
					long itenum = 0;
					long itecontinue = 0;
					do{
						itecontinue = 0;
						D_RECT selrect;
						selrect.xmax = itedot.x + MINRECTBUFFER;
						selrect.xmin = itedot.x - MINRECTBUFFER;
						selrect.ymax = itedot.y + MINRECTBUFFER;
						selrect.ymin = itedot.y - MINRECTBUFFER;
						CSFeatureSet selectset;
						lineCls->RectSelect(-1,&selrect,&selectset,0);
						long tselnum = selectset.GetObjCount();
						if(selectset.GetObjCount()>1){
							TYPE_OBJ_ID *objidarr = new TYPE_OBJ_ID [tselnum];
							D_DOT **dotarr = new D_DOT*[tselnum];
							int *dotarrnum = new int [tselnum];
							D_DOT *vecarr = new D_DOT[tselnum];
							int arri = 0;
							
							double mindegree = 0;
							D_DOT choosedot;
							D_DOT choosevec;
							TYPE_OBJ_ID chooseobjid = 0;
							double chooselength = 0;

							selectset.MoveFirst();
							do{
								TYPE_OBJ_ID selid;
								selectset.GetObjID(&selid);
								if(IsInStroke[selid]==0){
									CAnyLine selpnt;
									selectset.line_Get(selid,&selpnt);
									long seldotnum = selpnt.m_varLin.dotNum();
									if(seldotnum>1){
										objidarr[arri] = selid;
										D_DOT *dot = (D_DOT*)selpnt.m_varLin.ptXY();
										dotarr[arri] = new D_DOT[seldotnum];
										for(int i=0;i<seldotnum;++i){
											dotarr[arri][i].x = dot[i].x;
											dotarr[arri][i].y = dot[i].y;
										}
										dotarrnum[arri] = seldotnum;
										++arri;
									}
								}
							}while(selectset.MoveNext()!=END_OF_SET);
							double maxdegree = 0;
							int theci = -1;
							int thebei = 0;
							for(int i=0;i<arri;++i){
								if(dotarr[i][0]==itedot){
									vecarr[i].x = dotarr[i][1].x - dotarr[i][0].x;
									vecarr[i].y = dotarr[i][1].y - dotarr[i][0].y;
									double cudegree = GetAngle(itevec,vecarr[i]);
									if(cudegree>CHOOSEDEGREE&&cudegree>maxdegree){
										maxdegree = cudegree;
										theci = i;
										thebei = 1;
									}
								}
								if(dotarr[i][dotarrnum[i]-1]==itedot){
									vecarr[i].x = dotarr[i][dotarrnum[i]-2].x - dotarr[i][dotarrnum[i]-1].x;
									vecarr[i].y = dotarr[i][dotarrnum[i]-2].y - dotarr[i][dotarrnum[i]-1].y;
									double cudegree = GetAngle(itevec,vecarr[i]);
									if(cudegree>CHOOSEDEGREE&&cudegree>maxdegree){
										maxdegree = cudegree;
										theci = i;
										thebei = -1;
									}
								}
							}
							if(theci>=0){
								int ischoose = 1;
								for(int i=0;i<arri;++i){
									double cudegree = GetAngle(vecarr[i],vecarr[theci]);
									if(cudegree>maxdegree){
										ischoose = -1;
									}
								}
								if(ischoose>0){
									chooselength = GetLineLength(dotarr[theci],dotarrnum[theci]);
									itecontinue = 1;
									chooseobjid = objidarr[theci];
									if(thebei>0){
										choosedot.x = dotarr[theci][dotarrnum[theci]-1].x;
										choosedot.y = dotarr[theci][dotarrnum[theci]-1].y;
										choosevec.x = dotarr[theci][dotarrnum[theci]-2].x - dotarr[theci][dotarrnum[theci]-1].x;
										choosevec.y = dotarr[theci][dotarrnum[theci]-2].y - dotarr[theci][dotarrnum[theci]-1].y;
									}
									else{
										choosedot.x = dotarr[theci][0].x;
										choosedot.y = dotarr[theci][0].y;
										choosevec.x = dotarr[theci][1].x - dotarr[theci][0].x;
										choosevec.y = dotarr[theci][1].y - dotarr[theci][0].y;
									}
								}
							}

									
							if(1==itecontinue){
								IsInStroke[chooseobjid] = 1;
								st[snum].AddRoad(chooseobjid,chooselength);
								itedot.x = choosedot.x;
								itedot.y = choosedot.y;
								itevec.x = choosevec.x;
								itevec.y = choosevec.y;
							}
							delete []objidarr;
							for(int i=0;i<arri;++i){
								delete []dotarr[i];
							}
							delete []dotarr;
							//delete []*dotarr;
							delete []dotarrnum;
							delete []vecarr;
						}
						
						if(0==itecontinue&&0==itenum){
							itedot.x = lastdot.x;
							itedot.y = lastdot.y;
							itevec.x = lastvec.x;
							itevec.y = lastvec.y;
							itenum = 1;
							itecontinue = 1;
						}
							
							
						
					}while(itecontinue);
				}
				++snum;
			}
		}while(lineset.MoveNext()!=END_OF_SET);
		delete []IsInStroke;
	}
	renum = snum;
}
//ȡеstroke
void WriteStroke(CSFeatureCls *linecls,CSFeatureCls *strokecls,CSFeatureCls *restcls,char filename[]){
	long linenum = linecls->GetObjCount();
	CStroke *strokearr = new CStroke[linenum];
	long snum = 0;
	GetAllStroke(linecls,strokearr,snum);
	ofstream strokefile;
	strokefile.open(filename);
	for(int i=0;i<snum;++i){
		strokefile<<i<<":   "<<strokearr[i].length<<"    ";
		for(int j=0;j<strokearr[i].roadnum;++j){
			strokefile<<strokearr[i].roadindex[j]<<"    ";
		}
		if(strokearr[i].length>STROKEYUZHI){
			for(int j=0;j<strokearr[i].roadnum;++j){
				CAnyLine linepnt;
				linecls->line_Get(strokearr[i].roadindex[j],&linepnt);
				strokecls->line_Append(&linepnt);
			}
		}	
		else{
			for(int j=0;j<strokearr[i].roadnum;++j){
				CAnyLine linepnt;
				linecls->line_Get(strokearr[i].roadindex[j],&linepnt);
				restcls->line_Append(&linepnt);
			}
		}
		strokefile<<endl;
	}
	delete []strokearr;
}

void WriteDelete0(CSFeatureCls *incls,CSFeatureCls *outcls,CSFeatureCls *restcls){
	CSFeatureSet inset;
	incls->RectSelect(-1,NULL,&inset);
	if(inset.GetObjCount()>0){
		inset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			inset.GetObjID(&objid);
			CAnyLine linepnt;
			inset.line_Get(objid,&linepnt);
			long dotnum = linepnt.m_varLin.dotNum();
			D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();

			D_RECT torect;
			torect.xmax = dot[0].x + MINRECTBUFFER;
			torect.xmin = dot[0].x - MINRECTBUFFER;
			torect.ymax = dot[0].y + MINRECTBUFFER;
			torect.ymin = dot[0].y - MINRECTBUFFER;
			CSFeatureSet toset;
			incls->RectSelect(-1,&torect,&toset,0);
			long tonum = toset.GetObjCount();

			D_RECT fromrect;
			fromrect.xmax = dot[dotnum-1].x + MINRECTBUFFER;
			fromrect.xmin = dot[dotnum-1].x - MINRECTBUFFER;
			fromrect.ymax = dot[dotnum-1].y + MINRECTBUFFER;
			fromrect.ymin = dot[dotnum-1].y - MINRECTBUFFER;
			CSFeatureSet fromset;
			incls->RectSelect(-1,&fromrect,&fromset,0);
			long fromnum = fromset.GetObjCount();
			if(tonum>1&&fromnum>1){
				outcls->line_Append(&linepnt);
			}
			else{
				restcls->line_Append(&linepnt);
			}


		}while(inset.MoveNext()!=END_OF_SET);
	}
}
//ɾжΪ1
void TheDelete0(CSFeatureCls *outcls,CSFeatureCls *restcls){
	long deletenum = 0;
	do{
		CSFeatureSet outset;
		outcls->RectSelect(-1,NULL,&outset);
		deletenum = 0;
		outset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			outset.GetObjID(&objid);
			CAnyLine linepnt;
			outset.line_Get(objid,&linepnt);
			long dotnum = linepnt.m_varLin.dotNum();
			D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();

			D_RECT torect;
			torect.xmax = dot[0].x + MINRECTBUFFER;
			torect.xmin = dot[0].x - MINRECTBUFFER;
			torect.ymax = dot[0].y + MINRECTBUFFER;
			torect.ymin = dot[0].y - MINRECTBUFFER;
			CSFeatureSet toset;
			outcls->RectSelect(-1,&torect,&toset,0);
			long tonum = toset.GetObjCount();

			D_RECT fromrect;
			fromrect.xmax = dot[dotnum-1].x + MINRECTBUFFER;
			fromrect.xmin = dot[dotnum-1].x - MINRECTBUFFER;
			fromrect.ymax = dot[dotnum-1].y + MINRECTBUFFER;
			fromrect.ymin = dot[dotnum-1].y - MINRECTBUFFER;
			CSFeatureSet fromset;
			outcls->RectSelect(-1,&fromrect,&fromset,0);
			long fromnum = fromset.GetObjCount();
			if(tonum<2||fromnum<2){
				restcls->line_Append(&linepnt);
				outcls->line_Del(objid);
				++deletenum;
			}
			
		}while(outset.MoveNext()!=END_OF_SET);
	}while(deletenum>0);
}
//ֱϵĵ
void ConnectDot(const D_DOT *dot1,long dot1num,const D_DOT*dot2,long dot2num,D_DOT*re){
	if(dot1[0]==dot2[0]){
		int j = 0;
		for(int i=dot1num-1;i>=0;--i,++j){
			re[j].x = dot1[i].x;
			re[j].y = dot1[i].y;
		}
		for(int i=1;i<dot2num;++i,++j){
			re[j].x = dot2[i].x;
			re[j].y = dot2[i].y;
		}
	}
	else if(dot1[0]==dot2[dot2num-1]){
		int j = 0;
		for(int i=0;i<dot2num;++i,++j){
			re[j].x = dot2[i].x;
			re[j].y = dot2[i].y;
		}
		for(int i=1;i<dot1num;++i,++j){
			re[j].x = dot1[i].x;
			re[j].y = dot1[i].y;
		}
	}
	else if(dot1[dot1num-1]==dot2[0]){
		int j = 0;
		for(int i=0;i<dot1num;++i,++j){
			re[j].x = dot1[i].x;
			re[j].y = dot1[i].y;
		}
		for(int i=1;i<dot2num;++i,++j){
			re[j].x = dot2[i].x;
			re[j].y = dot2[i].y;
		}
	}
	else if(dot1[dot1num-1]==dot2[dot2num-1]){
		int j = 0;
		for(int i=0;i<dot1num;++i,++j){
			re[j].x = dot1[i].x;
			re[j].y = dot1[i].y;
		}
		for(int i=dot2num-2;i>=0;--i,++j){
			re[j].x = dot2[i].x;
			re[j].y = dot2[i].y;
		}
	}
	else{
		AfxMessageBox("dot error");
	}
}
//ֱ
void ConnectLine(CSFeatureCls* linecls){
	CSFeatureSet lineset;
	linecls->RectSelect(-1,NULL,&lineset);
	if(lineset.GetObjCount()>0){
		lineset.MoveLast();
		TYPE_OBJ_ID lastid;
		lineset.GetObjID(&lastid);
		int *IsCom = new int [lastid + 1];
		for(int i=0;i<lastid+1;++i){
			IsCom[i] = 0;
		}
		lineset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			lineset.GetObjID(&objid);
			if(0==IsCom[objid]){
				IsCom[objid] = 1;
				CAnyLine linepnt;
				lineset.line_Get(objid,&linepnt);
				long dotnum = linepnt.m_varLin.dotNum();
				D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();
				TYPE_OBJ_ID iteid;
				D_DOT itedot,itevec;
				iteid = objid;
				itedot.x = dot[0].x;
				itedot.y = dot[0].y;
				itevec.x = dot[1].x - dot[0].x;
				itevec.y = dot[1].y - dot[0].y;
				D_DOT *insertdot = new D_DOT[dotnum];
				long insertdotnum = dotnum;
				for(int i=0;i<dotnum;++i){
					insertdot[i].x = dot[i].x;
					insertdot[i].y = dot[i].y;
				}
				long itenum = 0;
				long itecon = 0;
				long thedel = 0;
				do{
					itecon = 0;
					D_RECT iterect;
					iterect.xmax = itedot.x + MINRECTBUFFER;
					iterect.xmin = itedot.x - MINRECTBUFFER;
					iterect.ymax = itedot.y + MINRECTBUFFER;
					iterect.ymin = itedot.y - MINRECTBUFFER;
					CSFeatureSet iteset;
					linecls->RectSelect(-1,&iterect,&iteset,0);
					long connum = iteset.GetObjCount();
					if(iteset.GetObjCount()==2){
						iteset.MoveFirst();
						TYPE_OBJ_ID selid;
						iteset.GetObjID(&selid);
						if(iteid==selid){
							iteset.MoveNext();
							iteset.GetObjID(&selid);
							if(iteid==selid){
								AfxMessageBox("objid error");
							}
						}
						CAnyLine selpnt;
						iteset.line_Get(selid,&selpnt);
						long selnum = selpnt.m_varLin.dotNum();
						D_DOT *seldot = (D_DOT*)selpnt.m_varLin.ptXY();
						D_DOT selvec;
						D_DOT nextdot;
						D_DOT nextvec;
						if(seldot[0]==itedot){
							selvec.x = seldot[1].x - seldot[0].x;
							selvec.y = seldot[1].y - seldot[0].y;

							nextvec.x = seldot[selnum-2].x - seldot[selnum-1].x;
							nextvec.y = seldot[selnum-2].y - seldot[selnum-1].y;
							nextdot.x = seldot[selnum-1].x;
							nextdot.y = seldot[selnum-1].y;
						}
						else if(seldot[selnum-1]==itedot){
							selvec.x = seldot[selnum-2].x - seldot[selnum-1].x;
							selvec.y = seldot[selnum-2].y - seldot[selnum-1].y;

							nextvec.x = seldot[1].x - seldot[0].x;
							nextvec.y = seldot[1].y - seldot[0].y;
							nextdot.x = seldot[0].x;
							nextdot.y = seldot[0].y;
						}
						else{
							AfxMessageBox("dot error");
						}
						double cudegree = 0;
						cudegree = GetAngle(itevec,selvec);
						if(cudegree>CHOOSEDEGREE){
							D_DOT* tdot = new D_DOT[insertdotnum + selnum - 1];
							ConnectDot(insertdot,insertdotnum,seldot,selnum,tdot);
							delete[]insertdot;
							insertdot = tdot;
							insertdotnum = insertdotnum + selnum - 1;
							itedot.x = nextdot.x;
							itedot.y = nextdot.y;
							itevec.x = nextvec.x;
							itevec.y = nextvec.y;
							iteid = selid;
							itecon = 1;
							IsCom[objid] = 2;
							IsCom[selid] = 2;
							thedel = 1;
						}

					}
					if(0==itenum&&0==itecon){
						itedot.x = dot[dotnum-1].x;
						itedot.y = dot[dotnum-1].y;
						itevec.x = dot[dotnum-2].x - dot[dotnum-1].x;
						itevec.y = dot[dotnum-2].y - dot[dotnum-1].y;
						iteid = objid;
						itecon = 1;
						itenum = 1;
					}
				}while(itecon!=0);
				if(1==thedel){
					CAnyLine insertline;
					insertline.m_varLin.Set(insertdot,insertdotnum);
					linecls->line_Append(&insertline);
				}
				delete []insertdot;
			}
		}while(lineset.MoveNext()!=END_OF_SET);
		for(int i=0;i<lastid+1;++i){
			if(2==IsCom[i]){
				linecls->line_Del(i);
			}
		}
		delete []IsCom;
	}
}

void TheRestroe(CSFeatureCls *incls,CSFeatureCls *outcls){
	long deletenum = 0;
	do{
		CSFeatureSet inset;
		incls->RectSelect(-1,NULL,&inset);
		deletenum = 0;
		inset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			inset.GetObjID(&objid);
			CAnyLine linepnt;
			inset.line_Get(objid,&linepnt);
			outcls->line_Append(&linepnt);
			
		}while(inset.MoveNext()!=END_OF_SET);
	}while(deletenum>0);
}




bool operator <(const D_DOT &dot1,const D_DOT&dot2){
	if((abs(dot1.x-dot2.x)>MINDOUBLE)&&(dot1.x<dot2.x)){
		return true;
	}
	if ((abs(dot1.x-dot2.x)<MINDOUBLE)&&(dot1.y<dot2.y)){
		return true;
	}
	return false;
}

//ȡ͹///
double getvecangle(D_DOT a){
	if(a.x==0){
		if(a.y<0){
			return (DBL_MAX-2)*-1;
		}
		else{
			return DBL_MAX;
		}
	}
	else{
		return a.y/a.x;
	}
}


bool compare(M_VEC &a,M_VEC &b){
	if(a.angle<b.angle)
		return true;
	return false;
}
double getwaiji(D_DOT a,D_DOT b){
	return a.x*b.y - b.x*a.y;
}
double getlength(D_DOT dot1,D_DOT dot2){
	return sqrt((dot1.x-dot2.x)*(dot1.x-dot2.x)+(dot1.y-dot2.y)*(dot1.y-dot2.y));
}
double getlength(D_DOT dot){
	return sqrt(dot.x*dot.x + dot.y*dot.y);
}
double getzuo(D_DOT dot1,D_DOT dot2,D_DOT dot3){
	// (y1 C y2) * x + (x2 C x1) * y + x1 * y2 C x2 * y1;
	 double temp = (dot1.y - dot2.y)*dot3.x + (dot2.x - dot1.x)*dot3.y + dot1.x*dot2.y - dot2.x*dot1.y;
	 return temp;
}

void getoutdot(D_DOT dot1,D_DOT dot2,D_DOT dot3,D_DOT &outdot){
	if(dot1.y==dot2.y&&dot2.y==dot3.y){
		if(dot3.x>dot2.x){
			outdot.x = dot2.x;
			outdot.y = dot2.y - BORLENGTH;
		}
		else{
			outdot.x = dot2.x;
			outdot.y = dot2.y + BORLENGTH;
		}
	}
	else if(dot1.x==dot2.x&&dot2.x==dot3.x){
		if(dot3.y>dot2.y){
			outdot.x = dot2.x + BORLENGTH;
			outdot.y = dot2.y;
		}
		else{
			outdot.x = dot2.x - BORLENGTH;
			outdot.y = dot2.y;
		}
	}
	else{
		D_DOT vec1,vec2;
		vec1.x = dot1.x - dot2.x;
		vec1.y = dot1.y - dot2.y;
		vec2.x = dot3.x - dot2.x;
		vec2.y = dot3.y - dot2.y;
		double dotang = GetAngle(vec1,vec2);
		dotang = cos((180.0 - dotang/2.0)*(M_PI/180.0));
		double t1 = dotang * BORLENGTH *getlength(vec1) /vec1.y;
		double a = (vec1.x/vec1.y)*(vec1.x/vec1.y) + 1;
		double b = -2.0*t1*(vec1.x/vec1.y);
		double c = t1*t1 - BORLENGTH*BORLENGTH;
		D_DOT outvec;
		outvec.x = (b*(-1) + sqrt(b*b - 4.0*a*c))/(2.0*a);
		outvec.y = t1 - outvec.x * ((vec1.x/vec1.y));
		outdot.x = outvec.x + dot2.x;
		outdot.y = outvec.y + dot2.y;
		if(getzuo(dot1,dot2,outdot)>0){
			outvec.x = (b*(-1) - sqrt(b*b - 4.0*a*c))/(2.0*a);
			outvec.y = t1 - outvec.x * ((vec1.x/vec1.y));
			outdot.x = outvec.x + dot2.x;
			outdot.y = outvec.y + dot2.y;
		}

		
		
	
	}
}

void convexhull(map<D_DOT,long>&tmap,CMultiLine *lin){
	map<D_DOT,long>::iterator  it;
	long dotnum = tmap.size();
	D_DOT *alldot = new D_DOT[dotnum];
	D_DOT mindot;
	it = tmap.begin();
	alldot[0].x = it->first.x;
	alldot[0].y = it->first.y;
	mindot.x = alldot[0].x;
	mindot.y = alldot[0].y;
	long mini = 0;
	it++;
	for(int i=1;it!=tmap.end();it++,i++){
		alldot[i].x = it->first.x;
		alldot[i].y = it->first.y;
		if(alldot[i].x<mindot.x){
			mini = i;
			mindot.x = alldot[i].x;
			mindot.y = alldot[i].y;
		}
	}
	M_VEC *vec = new M_VEC[dotnum];
	for(int i=0,j=0;i<dotnum;i++){
		if(i!=mini){
			vec[j].dot.x = alldot[i].x;
			vec[j].dot.y = alldot[i].y;
			D_DOT temp;
			temp.x = vec[j].dot.x - mindot.x;
			temp.y = vec[j].dot.y - mindot.y;
			vec[j].angle = getvecangle(temp);
			j++;
		}
	}
	sort(vec,vec+dotnum-1,compare);
	D_DOT *stackdot = new D_DOT[dotnum];
	long stacknum = 0;
	stackdot[stacknum].x = mindot.x;
	stackdot[stacknum].y = mindot.y;
	stacknum++;
	stackdot[stacknum].x = vec[0].dot.x;
	stackdot[stacknum].y = vec[0].dot.y;
	stacknum++;
	for(long i=1;i<dotnum-1;i++){
		D_DOT v1,v2;
		v1.x = stackdot[stacknum-2].x - stackdot[stacknum-1].x;
		v1.y = stackdot[stacknum-2].y - stackdot[stacknum-1].y;
		v2.x = vec[i].dot.x - stackdot[stacknum-1].x;
		v2.y = vec[i].dot.y - stackdot[stacknum-1].y;
		while(getwaiji(v2,v1)<=0){
			stacknum--;
			v1.x = stackdot[stacknum-2].x - stackdot[stacknum-1].x;
			v1.y = stackdot[stacknum-2].y - stackdot[stacknum-1].y;
			v2.x = vec[i].dot.x - stackdot[stacknum-1].x;
			v2.y = vec[i].dot.y - stackdot[stacknum-1].y;
		};
		stackdot[stacknum].x = vec[i].dot.x;
		stackdot[stacknum].y = vec[i].dot.y;
		stacknum++;
	}

	//stackdotŵõ͹ĵ㼯
	
	D_DOT *finaldot = new D_DOT[dotnum*2];
	finaldot[0].x = stackdot[0].x;
	finaldot[0].y = stackdot[0].y;
	int fj = 1;
	for(int i=1;i<stacknum;i++){
		int qu = getlength(stackdot[i],stackdot[i-1])/BORLENGTH;
		for(int h=1;h<qu;h++){
			finaldot[fj].x = stackdot[i-1].x*double(qu-h)/double(qu) + stackdot[i].x*double(h)/double(qu);
			finaldot[fj].y = stackdot[i-1].y*double(qu-h)/double(qu) + stackdot[i].y*double(h)/double(qu);
			fj++;
		}
		finaldot[fj].x = stackdot[i].x;
		finaldot[fj].y = stackdot[i].y;
		fj++;
	}
	int qu = getlength(stackdot[stacknum-1],stackdot[0])/BORLENGTH;
	for(int h=1;h<qu;h++){
		finaldot[fj].x = stackdot[stacknum-1].x*double(qu-h)/double(qu) + stackdot[0].x*double(h)/double(qu);
		finaldot[fj].y = stackdot[stacknum-1].y*double(qu-h)/double(qu) + stackdot[0].y*double(h)/double(qu);
		fj++;
	}
	//Ϊ͹ڵĽŻʹȷֲ
	D_DOT *enddot = new D_DOT[fj];
	for(int i=0;i<fj;++i){
		getoutdot(finaldot[(i+fj-1)%fj],finaldot[i],finaldot[(i+fj+1)%fj],enddot[i]);
	}
	for(int i=0;i<fj;++i){
		D_3DOT OT[2];
		OT[0].x = enddot[i].x;
		OT[0].y = enddot[i].y;
		OT[1].x = enddot[(i+1+fj)%fj].x;
		OT[1].y = enddot[(i+1+fj)%fj].y;
		CAnyLine anyline;
		anyline.m_varLin.Set(OT,2,3);
		lin->Append(&anyline);
		tmap.insert(make_pair(enddot[i],(i+1)*-1));
	}
	
}

void MakeDotMap(CSFeatureCls *cls,map<D_DOT,long>&dotmap,CMultiLine *lin,long &pointnum){
	long dotnum = 0;
	CSFeatureSet lineset;
	cls->RectSelect(-1,NULL,&lineset);
	if(lineset.GetObjCount()>0){
		CAnyLine linepnt;
		lineset.MoveFirst();
		do{
			lineset.line_Get(MOVE_CURRENT,&linepnt);
			long num = linepnt.m_varLin.dotNum();
			D_DOT *dot = (D_DOT*)linepnt.m_varLin.ptXY();
			if(dotmap.find(dot[0])==dotmap.end()){
				dotmap.insert(make_pair(dot[0],dotnum));
				++dotnum;
			}
			if(dotmap.find(dot[num-1])==dotmap.end()){
				dotmap.insert(make_pair(dot[num-1],dotnum));
				++dotnum;
			}
			D_3DOT OT[2];
			OT[0].x = dot[0].x;
			OT[0].y = dot[0].y;
			OT[1].x = dot[num-1].x ;
			OT[1].y = dot[num-1].y;
			CAnyLine anyline;
			anyline.m_varLin.Set(OT,2,3);
			lin->Append(&anyline);

		}while(lineset.MoveNext()!=END_OF_SET);
	}
	pointnum = dotnum;
	convexhull(dotmap,lin);
}
double GetDotLength(D_DOT *dot,long dotnum){
	double re = 0;
	for(int i=0;i<dotnum-1;++i){
		re += getlength(dot[i],dot[i+1]);
	}
	return re;
}

void SetMatchLine(CSFeatureCls *cls,CSFeatureCls *selcls,MatchLine *matline,long &matlinenum){
	CSFeatureSet lineset;
	cls->RectSelect(-1,NULL,&lineset);
	if(lineset.GetObjCount()>0){
		lineset.MoveFirst();
		do{
			TYPE_OBJ_ID objid;
			lineset.GetObjID(&objid);
			CAnyLine linepnt;
			lineset.line_Get(objid,&linepnt);
			long dotnum = linepnt.m_varLin.dotNum();
			D_DOT*dot = (D_DOT*)linepnt.m_varLin.ptXY();
			double tre = GetDotLength(dot,dotnum);
			if(tre>MINDOUBLE){
				D_RECT rect;
				long cunum = 0;
				do{
					rect.xmax = dot[cunum].x + MINRECTBUFFER;
					rect.xmin = dot[cunum].x - MINRECTBUFFER;
					rect.ymax = dot[cunum].y + MINRECTBUFFER;
					rect.ymin = dot[cunum].y - MINRECTBUFFER;
					CSFeatureSet selset;
					selcls->RectSelect(-1,&rect,&selset,0);
					if(selset.GetObjCount()>0){
						selset.MoveFirst();
						do{
							TYPE_OBJ_ID selid;
							selset.GetObjID(&selid);
							int i = 0;
							for(i=0;i<matlinenum;++i){
								if(matline[i].lineid==selid){
									break;
								}
							}
							if(i==matlinenum){
								++matlinenum;
								CAnyLine selpnt;
								selset.line_Get(selid,&selpnt);
								long selnum = selpnt.m_varLin.dotNum();
								D_DOT *seldot = (D_DOT*)selpnt.m_varLin.ptXY();
								D_DOT setdot[2];
								setdot[0].x = seldot[0].x;
								setdot[0].y = seldot[0].y;
								setdot[1].x = seldot[selnum-1].x;
								setdot[1].y = seldot[selnum-1].y;
								matline[i].setdot(selid,setdot);
							}
							D_DOT insertdot[2];
							insertdot[0].x = dot[cunum].x;
							insertdot[0].y = dot[cunum].y;
							insertdot[1].x = dot[dotnum-1-cunum].x;
							insertdot[1].y = dot[dotnum-1-cunum].y;
							matline[i].insertdot(insertdot);
						}while(selset.MoveNext()!=END_OF_SET);
					}
					cunum = dotnum - 1 - cunum;
				}while(cunum!=0);
			}
		}while(lineset.MoveNext()!=END_OF_SET);
	}
}

void swaptri(m_triangle &t1,m_triangle &t2){
	m_triangle t3;
	t3 = t1;
	t1 = t2;
	t2 = t3;
}

void swappoint(m_point &p1,m_point &p2){
	m_point t;
	t.id = p1.id;
	t.dot.x = p1.dot.x;
	t.dot.y = p1.dot.y;
	p1.id = p2.id;
	p1.dot.x = p2.dot.x;
	p1.dot.y = p2.dot.y;
	p2.id = t.id;
	p2.dot.x = t.dot.x;
	p2.dot.y = t.dot.y;
}