#pragma once

#ifndef _DELAUNAY
#define _DELAUNAY
#endif

#include <algorithm>
#include <fstream>
#include <map>
#include <cmath>
#include <fstream>
#include "triangle.h"
#include "Cln_Bas70.h"

const double BUFLENGTH = 0.005; 
const double BORLENGTH = 0.003;
const double YUZHIA = 0.85;
const double YUZHIB = 0.65;
const char RIGHTFILENAME[50] = {"raid_right.txt"};
const char FILENAME[30] ="raid\\outfile_zhuan180.txt";
const char errorfilename[30] = "raid\\error_zhuan180.txt";
const char resultfilename[30] = "raid\\result_zhuan180.txt";
const double MINRECTBUFFER = 0.00005;
const double CHOOSEDEGREE = 150;
const double M_PI = 3.14159265358979323846;
const double STROKEYUZHI = 0.0021443;  //0.01083

const double MINDOUBLE = 0.0001;


double getlength(D_DOT dot1,D_DOT dot2);
//ṹ
struct m_point{
	long id;
	D_DOT dot;
	m_point(){
	}
	bool operator ==(m_point&point){
		if(id==point.id){
			return true;
		}
		else 
			return false;
	}
	m_point (const m_point&point){
		m_point temp;
		id = point.id;
		dot.x = point.dot.x;
		dot.y = point.dot.y;
		//return temp;
	}
};
void swappoint(m_point &p1,m_point &p2);

//߽ṹֻ
struct m_line{
	m_point point[2];
	m_line(){
	}
	bool operator ==(m_line &line){
		if(line.point[0]==point[0]&&line.point[1]==point[1])
			return true;
		else
			return false;
	}
	m_line (m_line&line){
		point[0] = line.point[0];
		point[1] = line.point[1];
	}
};

//νṹ
struct m_triangle{
	m_point point[3];
	m_triangle(){}
	bool operator==(m_triangle &tri){
		int n = 0;
		for(int i=0;i<3;i++){
			for(int j=0;j<3;j++){
				if(point[i].id==tri.point[j].id){
					n++;
				}
			}
		}
		if(3==n){
			return true;
		}
		return false;
	}
	m_triangle (m_triangle&t){
		for(long i=0;i<3;i++){
			point[i] = t.point[i];
		}
	}
	//˳ʱ򶥵㡣
	void sorttri(){
		double x1 = 0;
		double y1 = 0;
		x1 = point[1].dot.x - point[0].dot.x;
		y1 = point[1].dot.y - point[0].dot.y;
		double x2 = 0;
		double y2 = 0;
		x2 = point[2].dot.x - point[0].dot.x;
		y2 = point[2].dot.y - point[0].dot.y;
		if((x1*y2-x2*y1)>0){
			swappoint(point[1],point[2]);
		}
	}
};
void swaptri(m_triangle &t1,m_triangle &t2);
//Сƥ䵥Ԫṹ
struct m_mixmatch{
	m_point cenpoint;
	m_triangle tris[20];
	long trinum;
	m_mixmatch(){
		trinum = 0;
	}
	m_mixmatch(m_mixmatch &t){
		cenpoint = t.cenpoint;
		trinum = t.trinum;
		for(long i=0;i<trinum;i++){
			tris[i] = t.tris[i];
		}
	}
	//
	void inserttri(m_triangle &tri){
		tris[trinum] = tri;
		trinum++;
	}
	void ResetTris(vector<m_point>vec){
		trinum = vec.size()-1;
		for(int i=0;i<trinum;++i){
			tris[i].point[0] = vec[vec.size()-1];
			tris[i].point[1] = vec[i];
			tris[i].point[2] = vec[i+1];
		}
		tris[trinum-1].point[2] = vec[0];

	}
	
	//дļ
	void off_file_write(char filename[],float pianyi){
		ofstream file;
		file.open(filename,ios::out);
		file<<"OFF"<<endl;
		file<<trinum*3<<"  "<<trinum<<"  0"<<endl;
		for(long i=0;i<trinum;i++){
			char temp[70] = {""};
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[0].dot.x + pianyi,tris[i].point[0].dot.y);
			file.write(temp,strlen(temp));
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[1].dot.x + pianyi,tris[i].point[1].dot.y);
			file.write(temp,strlen(temp));
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[2].dot.x + pianyi,tris[i].point[2].dot.y);
			file.write(temp,strlen(temp));
			//file<<tris[i].point[0].dot.x + pianyi<<"  "<<tris[i].point[0].dot.y<<"   0.00000"<<endl;
			//file<<tris[i].point[1].dot.x + pianyi<<"  "<<tris[i].point[1].dot.y<<"   0.00000"<<endl;
			//file<<tris[i].point[2].dot.x + pianyi<<"  "<<tris[i].point[2].dot.y<<"   0.00000"<<endl;
		}
		for(long i=0;i<trinum;i++){
			long j = 3*i;
			file<<"3  "<<j<<"  "<<j+1<<"  "<<j+2<<endl;
		}
	}
	//˳ʱ
	void clocksort(){
		for(long i=0;i<trinum;i++){
			if(tris[i].point[1]==cenpoint){
				swappoint(tris[i].point[0],tris[i].point[1]);
			}
			if(tris[i].point[2]==cenpoint){
				swappoint(tris[i].point[0],tris[i].point[2]);
			}
			tris[i].sorttri();
		}
		m_point jp;
		jp = tris[0].point[2];
		for(long i=1;i<trinum-1;i++){
			for(long j=i+1;j<trinum;j++){
				if(tris[j].point[1]==jp){
					swaptri(tris[i],tris[j]);
					continue;
				}
			}
			jp = tris[i].point[2];
		}
	}
	//ɾһ㣬عǽṹ
	void delpoint(long n){
		m_triangle ttri;
		ttri.point[0] = tris[n].point[0];
		ttri.point[1] = tris[n].point[1];
		ttri.point[2] = tris[(n+1)%trinum].point[2];
		m_triangle *newtri = new m_triangle[trinum-1];
		newtri[0] = ttri;
		long j = (n+2)%trinum;
		for(long i=1;i<trinum-1;i++){
			newtri[i] = tris[j];
			j = (j+1)%trinum;
		}
		for(long i=0;i<trinum-1;i++){
			tris[i] = newtri[i];
		}
		trinum = trinum - 1;
		//delete []newtri;

	}
	void getborpoint(m_point*t){
		for(int i=0;i<trinum;i++){
			t[i] = tris[i].point[2];
		}

	}
};

struct m_maxmatch{
	m_maxmatch(){
		pointnum = 0;
		trinum = 0;
	}
	m_point cenpoint;
	m_point borpoint[80];
	long pointnum;
	m_triangle tris[40];
	long trinum;
	void insertpoint(m_point &p){
		short k = 0;
		for(int i=0;i<pointnum;i++){
			if(p==borpoint[i]){
				k = 1;
				continue;
			}
		}
		if(p==cenpoint){
			k = 1;
		}
		if(0==k){
			borpoint[pointnum] = p;
			pointnum++;
		}
	}	
	void inserttriangle(m_triangle &t){
		short k = 0;
		for(long i=0;i<trinum;i++){
			if(t==tris[i]){
				k = 1;
				continue;
			}
		}
		if(0==k){
			tris[trinum] = t;
			trinum++;
			for(long i=0;i<3;i++){
				insertpoint(t.point[i]);
			}
		}
	}
	void insertmixmatch(m_mixmatch &t){
		for(long i=0;i<t.trinum;i++){
			inserttriangle(t.tris[i]);
		}
	}
	void off_file_write(char filename[],float pianyi){
		ofstream file;
		file.open(filename,ios::out);
		file<<"OFF"<<endl;
		file<<trinum*3<<"  "<<trinum<<"  0"<<endl;
		for(long i=0;i<trinum;i++){
			char temp[70] = {""};
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[0].dot.x + pianyi,tris[i].point[0].dot.y);
			file.write(temp,strlen(temp));
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[1].dot.x + pianyi,tris[i].point[1].dot.y);
			file.write(temp,strlen(temp));
			sprintf(temp,"%10.10f   %10.10f    0.0000 \n",tris[i].point[2].dot.x + pianyi,tris[i].point[2].dot.y);
			file.write(temp,strlen(temp));

			//file<<tris[i].point[0].dot.x + pianyi<<"  "<<tris[i].point[0].dot.y<<"   0.00000"<<endl;
			//file<<tris[i].point[1].dot.x + pianyi<<"  "<<tris[i].point[1].dot.y<<"   0.00000"<<endl;
			//file<<tris[i].point[2].dot.x + pianyi<<"  "<<tris[i].point[2].dot.y<<"   0.00000"<<endl;
		}
		for(long i=0;i<trinum;i++){
			long j = 3*i;
			file<<"3  "<<j<<"  "<<j+1<<"  "<<j+2<<endl;
		}
	}
};

class CStroke{
public:
	CStroke(){
		maxnum = 20;
		roadnum = 0;
		roadindex = new long[maxnum];
		length = 0;
	}
	
	long maxnum;
	long roadnum;
	long *roadindex;
	double length;
	void AddRoad(long roadID,double l){
		if(roadnum==maxnum){
			long *newroad = new long[maxnum + 20];
			for(int i=0;i<roadnum;++i){
				newroad[i] = roadindex[i];
			}
			delete roadindex;
			roadindex = newroad;
			maxnum = maxnum + 20;
		}
		roadindex[roadnum] = roadID;
		++roadnum;
		length += l;
	}
	CStroke(const CStroke &t){
		long *newroad = new long[t.roadnum];
		for(int i=0;i<t.roadnum;++i){
			newroad[i] = t.roadindex[i];
		}
		delete roadindex;
		roadindex = newroad;
		roadnum = t.roadnum;
		maxnum = t.maxnum;
		length = t.length;
	}
	CStroke& operator =(const CStroke &t){
		long *newroad = new long[t.roadnum];
		for(int i=0;i<t.roadnum;++i){
			newroad[i] = t.roadindex[i];
		}
		delete this->roadindex;
		this->roadindex = newroad;
		this->roadnum = t.roadnum;
		this->maxnum = t.maxnum;
		this->length = t.length;
		return *this;
	}

	~CStroke(){
		delete []roadindex;
	}
};
struct M_VEC{
	D_DOT dot;
	double angle;
};
struct MatchLine{
	long lineid;
	m_point point[2];
	D_DOT linedot[20];
	long linedotnum;
	double length;
	MatchLine(){
		linedotnum = 0;
		lineid = -1;
		length  = 0;
	}
	MatchLine(MatchLine& line){
		lineid = line.lineid;
		point[0] = line.point[0];
		point[1] = line.point[1];
		linedotnum = line.linedotnum;
		length = line.length;
		for(int i=0;i<linedotnum;++i){
			linedot[i].x = line.linedot[i].x;
			linedot[i].y = line.linedot[i].y;
		}
	}
	void setdot(long id,D_DOT dot[],const long num=2){
		lineid = id;
		point[0].dot.x = dot[0].x;
		point[0].dot.y = dot[0].y;
		point[1].dot.x = dot[1].x;
		point[1].dot.y = dot[1].y;
		length = getlength(dot[0],dot[1]);
	}
	void insertdot(D_DOT dot[],const long num = 2){
		for(int i=0;i<num;++i){
			linedot[linedotnum].x = dot[i].x;
			linedot[linedotnum].y = dot[i].y;
			++linedotnum;
		}
	}
	bool IsMatch(long m_id[]){
		if(point[0].id==m_id[0]&&point[1].id==m_id[1]){
			return true;
		}
		if(point[0].id==m_id[1]&&point[1].id==m_id[0]){
			swappoint(point[0],point[1]);
			return true;
		}
		return false;
	}

};
struct LineCP{
	MatchLine linecp[2];
	void SetLineCP(const MatchLine&line1,const MatchLine&line2){
		linecp[0] = line1;
		linecp[1] = line2;
	}
	void MatchLineDot(CSFeatureCls *recls){
		if(linecp[0].length>MINDOUBLE&&linecp[1].length>MINDOUBLE){

			D_DOT linevec[2];
			linevec[0].x = linecp[0].point[1].dot.x - linecp[0].point[0].dot.x;
			linevec[0].y = linecp[0].point[1].dot.y - linecp[0].point[0].dot.y;

			linevec[1].x = linecp[1].point[1].dot.x - linecp[1].point[0].dot.x;
			linevec[1].y = linecp[1].point[1].dot.y - linecp[1].point[0].dot.y;
			for(int i=0;i<linecp[0].linedotnum;){
				double weizhi = getlength(linecp[0].linedot[i],linecp[0].point[0].dot);
				weizhi  = weizhi/linecp[0].length;
				D_DOT vec;
				vec.x = linecp[0].linedot[i+1].x - linecp[0].linedot[i].x;
				vec.y = linecp[0].linedot[i+1].y - linecp[0].linedot[i].y;
				double chayi = 2;
				int choosej = 0;
				for(int j=0;j<linecp[1].linedotnum;){
					double weizhi2 = getlength(linecp[1].linedot[j],linecp[1].point[0].dot);
					weizhi2 = weizhi2/linecp[1].length;
					D_DOT vec2;
					vec2.x = linecp[1].linedot[j+1].x - linecp[1].linedot[j].x;
					vec2.x = linecp[1].linedot[j+1].y - linecp[1].linedot[j].y;
					double tchayi = fabs(weizhi-weizhi2);
					if(tchayi<chayi){
						chayi = tchayi;
						choosej = j;
					}
					j = j + 2;
				}
				if(chayi<0.1){
					D_DOT insertdot[2];
					insertdot[0].x = linecp[0].linedot[i].x;
					insertdot[0].y = linecp[0].linedot[i].y;
					insertdot[1].x = linecp[1].linedot[choosej].x;
					insertdot[1].y = linecp[1].linedot[choosej].y;
					CAnyLine insertpnt;
					insertpnt.m_varLin.Set(insertdot,2);
					recls->line_Append(&insertpnt);
				}
				i = i + 2;
			}
		}
	}
};


double GetAngle(D_DOT vec1,D_DOT vec2);
bool operator ==(const D_DOT &dot1,const D_DOT&dot2);
double Getlength(D_DOT dot1,D_DOT dot2);
double GetLineLength(D_DOT* dot,int num);
void GetAllStroke(CSFeatureCls *lineCls,CStroke *st,long &renum);
void WriteStroke(CSFeatureCls *linecls,CSFeatureCls *strokecls,CSFeatureCls *restcls,char filename[]);
void WriteDelete0(CSFeatureCls *incls,CSFeatureCls *outcls,CSFeatureCls *restcls);
void TheDelete0(CSFeatureCls *outcls,CSFeatureCls *restcls);
void ConnectDot(const D_DOT *dot1,long dot1num,const D_DOT*dot2,long dot2num,D_DOT*re);
void ConnectLine(CSFeatureCls* linecls);
void TheRestroe(CSFeatureCls *incls,CSFeatureCls *outcls);
bool operator <(const D_DOT &dot1,const D_DOT&dot2);
double getvecangle(D_DOT a);
bool compare(M_VEC &a,M_VEC &b);
double getwaiji(D_DOT a,D_DOT b);

double getlength(D_DOT dot);
double getzuo(D_DOT dot1,D_DOT dot2,D_DOT dot3);
void getoutdot(D_DOT dot1,D_DOT dot2,D_DOT dot3,D_DOT &outdot);
void convexhull(map<D_DOT,long>&tmap,CMultiLine *lin);
void MakeDotMap(CSFeatureCls *cls,map<D_DOT,long>&dotmap,CMultiLine *lin,long&pointnum);
void SetMatchLine(CSFeatureCls *cls,CSFeatureCls *selcls,MatchLine *matline,long &matlinenum);
double GetDotLength(D_DOT *dot,long dotnum);